Index: trunk/BNC/qwt/qwt_picker.cpp
===================================================================
--- trunk/BNC/qwt/qwt_picker.cpp	(revision 8127)
+++ trunk/BNC/qwt/qwt_picker.cpp	(revision 9383)
@@ -53,10 +53,10 @@
     if ( l.x1() == l.x2() )
     {
-        region += QRect( l.x1() - pw2, l.y1(), 
+        region += QRect( l.x1() - pw2, l.y1(),
             pw, l.y2() ).normalized();
     }
     else if ( l.y1() == l.y2() )
     {
-        region += QRect( l.x1(), l.y1() - pw2, 
+        region += QRect( l.x1(), l.y1() - pw2,
             l.x2(), pw ).normalized();
     }
@@ -78,14 +78,14 @@
 
 class QwtPickerTracker: public QwtWidgetOverlay
-{                                  
+{
 public:
     QwtPickerTracker( QwtPicker *, QWidget * );
-    
+
 protected:
     virtual void drawOverlay( QPainter * ) const;
     virtual QRegion maskHint() const;
-    
+
     QwtPicker *d_picker;
-};  
+};
 
 
@@ -105,5 +105,5 @@
     {
     }
-        
+
     bool enabled;
 
@@ -558,5 +558,5 @@
                 case VLineRubberBand:
                 {
-                    mask += qwtMaskRegion( QLine( pos.x(), pRect.top(), 
+                    mask += qwtMaskRegion( QLine( pos.x(), pRect.top(),
                         pos.x(), pRect.bottom() ), pw );
                     break;
@@ -564,5 +564,5 @@
                 case HLineRubberBand:
                 {
-                    mask += qwtMaskRegion( QLine( pRect.left(), pos.y(), 
+                    mask += qwtMaskRegion( QLine( pRect.left(), pos.y(),
                         pRect.right(), pos.y() ), pw );
                     break;
@@ -570,7 +570,7 @@
                 case CrossRubberBand:
                 {
-                    mask += qwtMaskRegion( QLine( pos.x(), pRect.top(), 
+                    mask += qwtMaskRegion( QLine( pos.x(), pRect.top(),
                         pos.x(), pRect.bottom() ), pw );
-                    mask += qwtMaskRegion( QLine( pRect.left(), pos.y(), 
+                    mask += qwtMaskRegion( QLine( pRect.left(), pos.y(),
                         pRect.right(), pos.y() ), pw );
                     break;
@@ -752,27 +752,31 @@
    depends on the application requirements. F.e. :
 
-   - A rectangular selection might need to have a specific aspect ratio only.\n
-   - A selection could accept non intersecting polygons only.\n
-   - ...\n
+     - A rectangular selection might need to have a specific aspect ratio only.
+     - A selection could accept non intersecting polygons only.
+     - ...
 
    The example below is for a rectangular selection, where the first
    point is the center of the selected rectangle.
+
   \par Example
-  \verbatim QPolygon MyPicker::adjustedPoints(const QPolygon &points) const
-{
-    QPolygon adjusted;
-    if ( points.size() == 2 )
-    {
-        const int width = qAbs(points[1].x() - points[0].x());
-        const int height = qAbs(points[1].y() - points[0].y());
-
-        QRect rect(0, 0, 2 * width, 2 * height);
-        rect.moveCenter(points[0]);
-
-        adjusted += rect.topLeft();
-        adjusted += rect.bottomRight();
-    }
-    return adjusted;
-}\endverbatim\n
+  \code
+    QPolygon MyPicker::adjustedPoints( const QPolygon &points ) const
+    {
+        QPolygon adjusted;
+        if ( points.size() == 2 )
+        {
+            const int width = qAbs( points[1].x() - points[0].x() );
+            const int height = qAbs( points[1].y() - points[0].y() );
+
+            QRect rect( 0, 0, 2 * width, 2 * height );
+            rect.moveCenter( points[0] );
+
+            adjusted += rect.topLeft();
+            adjusted += rect.bottomRight();
+        }
+        return adjusted;
+    }
+  \endcode
+  \endpar
 
   \param points Selected points
@@ -833,5 +837,5 @@
     {
         const QPoint last =
-            d_data->pickedPoints[int( d_data->pickedPoints.count() ) - 2];
+            d_data->pickedPoints[ d_data->pickedPoints.count() - 2 ];
 
         alignment |= ( pos.x() >= last.x() ) ? Qt::AlignRight : Qt::AlignLeft;
@@ -1183,5 +1187,5 @@
         case QEvent::MouseMove:
         {
-            const QMouseEvent *me = 
+            const QMouseEvent *me =
                 static_cast< const QMouseEvent * >( event );
             pos = me->pos();
@@ -1235,5 +1239,5 @@
         return;
 
-    d_data->pickedPoints.resize( 0 );
+    d_data->pickedPoints.clear();
     d_data->isActive = true;
     Q_EMIT activated( true );
@@ -1281,5 +1285,5 @@
             Q_EMIT selected( d_data->pickedPoints );
         else
-            d_data->pickedPoints.resize( 0 );
+            d_data->pickedPoints.clear();
 
         updateDisplay();
@@ -1315,7 +1319,5 @@
     if ( d_data->isActive )
     {
-        const int idx = d_data->pickedPoints.count();
-        d_data->pickedPoints.resize( idx + 1 );
-        d_data->pickedPoints[idx] = pos;
+        d_data->pickedPoints += pos;
 
         updateDisplay();
@@ -1333,16 +1335,13 @@
 void QwtPicker::move( const QPoint &pos )
 {
-    if ( d_data->isActive )
-    {
-        const int idx = d_data->pickedPoints.count() - 1;
-        if ( idx >= 0 )
-        {
-            if ( d_data->pickedPoints[idx] != pos )
-            {
-                d_data->pickedPoints[idx] = pos;
-
-                updateDisplay();
-                Q_EMIT moved( pos );
-            }
+    if ( d_data->isActive && !d_data->pickedPoints.isEmpty() )
+    {
+        QPoint &point = d_data->pickedPoints.last();
+        if ( point != pos )
+        {
+            point = pos;
+
+            updateDisplay();
+            Q_EMIT moved( pos );
         }
     }
@@ -1357,17 +1356,15 @@
 void QwtPicker::remove()
 {
-    if ( d_data->isActive )
-    {
-        const int idx = d_data->pickedPoints.count() - 1;
-        if ( idx > 0 )
-        {
-            const int idx = d_data->pickedPoints.count();
-
-            const QPoint pos = d_data->pickedPoints[idx - 1];
-            d_data->pickedPoints.resize( idx - 1 );
-
-            updateDisplay();
-            Q_EMIT removed( pos );
-        }
+    if ( d_data->isActive && !d_data->pickedPoints.isEmpty() )
+    {
+#if QT_VERSION >= 0x050100
+        const QPoint pos = d_data->pickedPoints.takeLast();
+#else
+        const QPoint pos = d_data->pickedPoints.last();
+        d_data->pickedPoints.resize( d_data->pickedPoints.count() - 1 );
+#endif
+
+        updateDisplay();
+        Q_EMIT removed( pos );
     }
 }
@@ -1424,10 +1421,8 @@
     }
 
-    const double xRatio =
-        double( newSize.width() ) / double( oldSize.width() );
-    const double yRatio =
-        double( newSize.height() ) / double( oldSize.height() );
-
-    for ( int i = 0; i < int( d_data->pickedPoints.count() ); i++ )
+    const double xRatio = double( newSize.width() ) / double( oldSize.width() );
+    const double yRatio = double( newSize.height() ) / double( oldSize.height() );
+
+    for ( int i = 0; i < d_data->pickedPoints.count(); i++ )
     {
         QPoint &p = d_data->pickedPoints[i];
@@ -1472,5 +1467,5 @@
   Find the area of the observed widget, where selection might happen.
 
-  \return parentWidget()->contentsRect() 
+  \return parentWidget()->contentsRect()
 */
 QPainterPath QwtPicker::pickArea() const
@@ -1504,5 +1499,5 @@
             ( trackerMode() == ActiveOnly && isActive() ) )
         {
-            if ( trackerPen() != Qt::NoPen 
+            if ( trackerPen() != Qt::NoPen
                 && !trackerRect( QFont() ).isEmpty() )
             {
Index: trunk/BNC/qwt/qwt_picker.h
===================================================================
--- trunk/BNC/qwt/qwt_picker.h	(revision 8127)
+++ trunk/BNC/qwt/qwt_picker.h	(revision 9383)
@@ -59,11 +59,14 @@
 
   \par Example
-  \verbatim #include <qwt_picker.h>
-#include <qwt_picker_machine.h>
-
-QwtPicker *picker = new QwtPicker(widget);
-picker->setStateMachine(new QwtPickerDragRectMachine);
-picker->setTrackerMode(QwtPicker::ActiveOnly);
-picker->setRubberBand(QwtPicker::RectRubberBand); \endverbatim\n
+  \code
+    #include <qwt_picker.h>
+    #include <qwt_picker_machine.h>
+
+    QwtPicker *picker = new QwtPicker(widget);
+    picker->setStateMachine(new QwtPickerDragRectMachine);
+    picker->setTrackerMode(QwtPicker::ActiveOnly);
+    picker->setRubberBand(QwtPicker::RectRubberBand);
+  \endcode
+  \endpar
 
   The state machine triggers the following commands:
@@ -308,6 +311,6 @@
     virtual void widgetLeaveEvent( QEvent * );
 
-    virtual void stretchSelection( const QSize &oldSize,
-                                   const QSize &newSize );
+    virtual void stretchSelection(
+        const QSize &oldSize, const QSize &newSize );
 
     virtual void updateDisplay();
Index: trunk/BNC/qwt/qwt_plot.cpp
===================================================================
--- trunk/BNC/qwt/qwt_plot.cpp	(revision 8127)
+++ trunk/BNC/qwt/qwt_plot.cpp	(revision 9383)
@@ -28,21 +28,19 @@
     if ( on )
     {
-        QObject::connect( 
-            plot, SIGNAL( legendDataChanged(
-                const QVariant &, const QList<QwtLegendData> & ) ),
-            plot, SLOT( updateLegendItems( 
-                const QVariant &, const QList<QwtLegendData> & ) ) );
+        QObject::connect(
+            plot, SIGNAL(legendDataChanged(QVariant,QList<QwtLegendData>)),
+            plot, SLOT(updateLegendItems(QVariant,QList<QwtLegendData>))
+        );
     }
     else
     {
-        QObject::disconnect( 
-            plot, SIGNAL( legendDataChanged(
-                const QVariant &, const QList<QwtLegendData> & ) ),
-            plot, SLOT( updateLegendItems( 
-                const QVariant &, const QList<QwtLegendData> & ) ) );
-    }
-}
-
-static void qwtSetTabOrder( 
+        QObject::disconnect(
+            plot, SIGNAL(legendDataChanged(QVariant,QList<QwtLegendData>) ),
+            plot, SLOT( updateLegendItems(QVariant,QList<QwtLegendData>))
+        );
+    }
+}
+
+static void qwtSetTabOrder(
     QWidget *first, QWidget *second, bool withChildren )
 {
@@ -196,5 +194,5 @@
   QwtPlot invokes methods of the canvas as meta methods ( see QMetaObject ).
   In opposite to using conventional C++ techniques like virtual methods
-  they allow to use canvas implementations that are derived from 
+  they allow to use canvas implementations that are derived from
   QWidget or QGLWidget.
 
@@ -210,5 +208,5 @@
     it is o.k. not to implement this method.
 
-  The default canvas is a QwtPlotCanvas 
+  The default canvas is a QwtPlotCanvas
 
   \param canvas Canvas Widget
@@ -317,5 +315,5 @@
 }
 
-/*! 
+/*!
   \return true if the autoReplot option is set.
   \sa setAutoReplot()
@@ -371,5 +369,5 @@
 
 /*!
-  Change the text the footer 
+  Change the text the footer
   \param text New text of the footer
 */
@@ -384,5 +382,5 @@
 
 /*!
-  Change the text the footer 
+  Change the text the footer
   \param text New text of the footer
 */
@@ -560,5 +558,5 @@
     if ( d_data->canvas )
     {
-        const bool ok = QMetaObject::invokeMethod( 
+        const bool ok = QMetaObject::invokeMethod(
             d_data->canvas, "replot", Qt::DirectConnection );
         if ( !ok )
@@ -724,5 +722,5 @@
     getCanvasMarginsHint( maps, canvas()->contentsRect(),
         margins[yLeft], margins[xTop], margins[yRight], margins[xBottom] );
-    
+
     bool doUpdate = false;
     for ( int axisId = 0; axisId < axisCnt; axisId++ )
@@ -766,6 +764,6 @@
 
   \note Usually canvasRect is contentsRect() of the plot canvas.
-        Due to a bug in Qt this rectangle might be wrong for certain 
-        frame styles ( f.e QFrame::Box ) and it might be necessary to 
+        Due to a bug in Qt this rectangle might be wrong for certain
+        frame styles ( f.e QFrame::Box ) and it might be necessary to
         fix the margins manually using QWidget::setContentsMargins()
 */
@@ -914,5 +912,5 @@
 
   insertLegend() will set the plot widget as parent for the legend.
-  The legend will be deleted in the destructor of the plot or when 
+  The legend will be deleted in the destructor of the plot or when
   another legend is inserted.
 
@@ -952,10 +950,7 @@
         if ( d_data->legend )
         {
-            connect( this, 
-                SIGNAL( legendDataChanged( 
-                    const QVariant &, const QList<QwtLegendData> & ) ),
-                d_data->legend, 
-                SLOT( updateLegend( 
-                    const QVariant &, const QList<QwtLegendData> & ) ) 
+            connect(
+                this, SIGNAL(legendDataChanged(QVariant,QList<QwtLegendData>)),
+                d_data->legend, SLOT(updateLegend(QVariant,QList<QwtLegendData>) )
             );
 
@@ -1088,5 +1083,5 @@
 
 /*!
-  \brief Attach/Detach a plot item 
+  \brief Attach/Detach a plot item
 
   \param plotItem Plot item
@@ -1116,5 +1111,5 @@
     if ( on )
         insertItem( plotItem );
-    else 
+    else
         removeItem( plotItem );
 
@@ -1168,5 +1163,5 @@
          that has bee generated from itemToInfo().
 
-  The default implementation simply tries to unwrap a QwtPlotItem 
+  The default implementation simply tries to unwrap a QwtPlotItem
   pointer:
 
Index: trunk/BNC/qwt/qwt_plot.h
===================================================================
--- trunk/BNC/qwt/qwt_plot.h	(revision 8127)
+++ trunk/BNC/qwt/qwt_plot.h	(revision 9383)
@@ -41,5 +41,5 @@
   can be configured separately for each axis.
 
-  The simpleplot example is a good starting point to see how to set up a 
+  The simpleplot example is a good starting point to see how to set up a
   plot widget.
 
@@ -47,27 +47,28 @@
 
   \par Example
-  The following example shows (schematically) the most simple
-  way to use QwtPlot. By default, only the left and bottom axes are
-  visible and their scales are computed automatically.
-  \verbatim
-#include <qwt_plot.h>
-#include <qwt_plot_curve.h>
-
-QwtPlot *myPlot = new QwtPlot("Two Curves", parent);
-
-// add curves
-QwtPlotCurve *curve1 = new QwtPlotCurve("Curve 1");
-QwtPlotCurve *curve2 = new QwtPlotCurve("Curve 2");
-
-// connect or copy the data to the curves
-curve1->setData(...);
-curve2->setData(...);
-
-curve1->attach(myPlot);
-curve2->attach(myPlot);
-
-// finally, refresh the plot
-myPlot->replot();
-\endverbatim
+    The following example shows (schematically) the most simple
+    way to use QwtPlot. By default, only the left and bottom axes are
+    visible and their scales are computed automatically.
+    \code
+      #include <qwt_plot.h>
+      #include <qwt_plot_curve.h>
+
+      QwtPlot *myPlot = new QwtPlot( "Two Curves", parent );
+
+      // add curves
+      QwtPlotCurve *curve1 = new QwtPlotCurve( "Curve 1" );
+      QwtPlotCurve *curve2 = new QwtPlotCurve( "Curve 2" );
+
+      // connect or copy the data to the curves
+      curve1->setData( ... );
+      curve2->setData( ... );
+
+      curve1->attach( myPlot );
+      curve2->attach( myPlot );
+
+      // finally, refresh the plot
+      myPlot->replot();
+    \endcode
+  \endpar
 */
 
@@ -76,5 +77,5 @@
     Q_OBJECT
 
-    Q_PROPERTY( QBrush canvasBackground 
+    Q_PROPERTY( QBrush canvasBackground
         READ canvasBackground WRITE setCanvasBackground )
     Q_PROPERTY( bool autoReplot READ autoReplot WRITE setAutoReplot )
@@ -122,5 +123,5 @@
         RightLegend,
 
-        //! The legend will be below the footer 
+        //! The legend will be below the footer
         BottomLegend,
 
@@ -150,5 +151,5 @@
 
     void setTitle( const QString & );
-    void setTitle( const QwtText &t );
+    void setTitle( const QwtText & );
     QwtText title() const;
 
@@ -159,5 +160,5 @@
 
     void setFooter( const QString & );
-    void setFooter( const QwtText &t );
+    void setFooter( const QwtText & );
     QwtText footer() const;
 
@@ -192,8 +193,8 @@
     bool axisEnabled( int axisId ) const;
 
-    void setAxisFont( int axisId, const QFont &f );
+    void setAxisFont( int axisId, const QFont & );
     QFont axisFont( int axisId ) const;
 
-    void setAxisScale( int axisId, double min, double max, double step = 0 );
+    void setAxisScale( int axisId, double min, double max, double stepSize = 0 );
     void setAxisScaleDiv( int axisId, const QwtScaleDiv & );
     void setAxisScaleDraw( int axisId, QwtScaleDraw * );
@@ -225,5 +226,5 @@
     // Legend
 
-    void insertLegend( QwtAbstractLegend *, 
+    void insertLegend( QwtAbstractLegend *,
         LegendPosition = QwtPlot::RightLegend, double ratio = -1.0 );
 
@@ -245,5 +246,5 @@
     void updateCanvasMargins();
 
-    virtual void getCanvasMarginsHint( 
+    virtual void getCanvasMarginsHint(
         const QwtScaleMap maps[], const QRectF &canvasRect,
         double &left, double &top, double &right, double &bottom) const;
@@ -268,5 +269,5 @@
 
     /*!
-      A signal with the attributes how to update 
+      A signal with the attributes how to update
       the legend entries for a plot item.
 
@@ -277,5 +278,5 @@
       \sa itemToInfo(), infoToItem(), QwtAbstractLegend::updateLegend()
      */
-    void legendDataChanged( const QVariant &itemInfo, 
+    void legendDataChanged( const QVariant &itemInfo,
         const QList<QwtLegendData> &data );
 
@@ -291,5 +292,5 @@
 private Q_SLOTS:
     void updateLegendItems( const QVariant &itemInfo,
-        const QList<QwtLegendData> &data );
+        const QList<QwtLegendData> &legendData );
 
 private:
Index: trunk/BNC/qwt/qwt_plot_abstract_barchart.h
===================================================================
--- trunk/BNC/qwt/qwt_plot_abstract_barchart.h	(revision 8127)
+++ trunk/BNC/qwt/qwt_plot_abstract_barchart.h	(revision 9383)
@@ -18,5 +18,5 @@
   \brief Abstract base class for bar chart items
 
-  In opposite to almost all other plot items bar charts can't be 
+  In opposite to almost all other plot items bar charts can't be
   displayed inside of their bounding rectangle and need a special
   API  how to calculate the width of the bars and how they affect
@@ -79,5 +79,5 @@
     double baseline() const;
 
-    virtual void getCanvasMarginHint( 
+    virtual void getCanvasMarginHint(
         const QwtScaleMap &xMap, const QwtScaleMap &yMap,
         const QRectF &canvasRect,
@@ -87,5 +87,5 @@
 protected:
     double sampleWidth( const QwtScaleMap &map,
-        double canvasSize, double dataSize,
+        double canvasSize, double boundingSize,
         double value ) const;
 
Index: trunk/BNC/qwt/qwt_plot_barchart.cpp
===================================================================
--- trunk/BNC/qwt/qwt_plot_barchart.cpp	(revision 8127)
+++ trunk/BNC/qwt/qwt_plot_barchart.cpp	(revision 9383)
@@ -22,5 +22,5 @@
     {
     }
- 
+
     ~PrivateData()
     {
@@ -121,5 +121,5 @@
 
   The bar chart will take the ownership of the symbol, hence the previously
-  set symbol will be delete by setting a new one. If \p symbol is 
+  set symbol will be delete by setting a new one. If \p symbol is
   \c NULL no symbol will be drawn.
 
@@ -305,5 +305,5 @@
 
 /*!
-  Draw a bar 
+  Draw a bar
 
   \param painter Painter
@@ -313,8 +313,8 @@
  */
 void QwtPlotBarChart::drawBar( QPainter *painter,
-    int sampleIndex, const QPointF &sample, 
+    int sampleIndex, const QPointF &sample,
     const QwtColumnRect &rect ) const
 {
-    const QwtColumnSymbol *specialSym = 
+    const QwtColumnSymbol *specialSym =
         specialSymbol( sampleIndex, sample );
 
@@ -330,8 +330,8 @@
     {
         // we build a temporary default symbol
-        QwtColumnSymbol sym( QwtColumnSymbol::Box );
-        sym.setLineWidth( 1 );
-        sym.setFrameStyle( QwtColumnSymbol::Plain );
-        sym.draw( painter, rect );
+        QwtColumnSymbol columnSymbol( QwtColumnSymbol::Box );
+        columnSymbol.setLineWidth( 1 );
+        columnSymbol.setFrameStyle( QwtColumnSymbol::Plain );
+        columnSymbol.draw( painter, rect );
     }
 
@@ -340,5 +340,5 @@
 
 /*!
-  Needs to be overloaded to return a 
+  Needs to be overloaded to return a
   non default symbol for a specific sample
 
@@ -348,5 +348,5 @@
   \return NULL, indicating to use the default symbol
  */
-QwtColumnSymbol *QwtPlotBarChart::specialSymbol( 
+QwtColumnSymbol *QwtPlotBarChart::specialSymbol(
     int sampleIndex, const QPointF &sample ) const
 {
@@ -429,11 +429,11 @@
    displays the default symbol.
 
-   \param index Index of the legend entry 
+   \param index Index of the legend entry
    \param size Icon size
 
-   \sa setLegendMode(), drawBar(), 
+   \sa setLegendMode(), drawBar(),
        QwtPlotItem::setLegendIconSize(), QwtPlotItem::legendData()
  */
-QwtGraphic QwtPlotBarChart::legendIcon( 
+QwtGraphic QwtPlotBarChart::legendIcon(
     int index, const QSizeF &size ) const
 {
@@ -453,5 +453,5 @@
     if ( d_data->legendMode == QwtPlotBarChart::LegendBarTitles )
         barIndex = index;
-        
+
     drawBar( &painter, barIndex, QPointF(), column );
 
Index: trunk/BNC/qwt/qwt_plot_barchart.h
===================================================================
--- trunk/BNC/qwt/qwt_plot_barchart.h	(revision 8127)
+++ trunk/BNC/qwt/qwt_plot_barchart.h	(revision 9383)
@@ -24,6 +24,6 @@
   a specialSymbol(). Otherwise it is rendered using a default symbol.
 
-  Depending on its orientation() the bars are displayed horizontally 
-  or vertically. The bars cover the interval between the baseline() 
+  Depending on its orientation() the bars are displayed horizontally
+  or vertically. The bars cover the interval between the baseline()
   and the value.
 
@@ -51,5 +51,5 @@
     enum LegendMode
     {
-        /*! 
+        /*!
           One entry on the legend showing the default symbol
           and the title() of the chart
@@ -68,5 +68,5 @@
     };
 
-    explicit QwtPlotBarChart( const QString &title = QString::null );
+    explicit QwtPlotBarChart( const QString &title = QString() );
     explicit QwtPlotBarChart( const QwtText &title );
 
@@ -77,5 +77,5 @@
     void setSamples( const QVector<QPointF> & );
     void setSamples( const QVector<double> & );
-    void setSamples( QwtSeriesData<QPointF> *series );
+    void setSamples( QwtSeriesData<QPointF> * );
 
     void setSymbol( QwtColumnSymbol * );
@@ -91,5 +91,5 @@
     virtual QRectF boundingRect() const;
 
-    virtual QwtColumnSymbol *specialSymbol( 
+    virtual QwtColumnSymbol *specialSymbol(
         int sampleIndex, const QPointF& ) const;
 
@@ -103,5 +103,5 @@
 
     virtual void drawBar( QPainter *,
-        int sampleIndex, const QPointF& point, 
+        int sampleIndex, const QPointF& sample,
         const QwtColumnRect & ) const;
 
Index: trunk/BNC/qwt/qwt_plot_canvas.cpp
===================================================================
--- trunk/BNC/qwt/qwt_plot_canvas.cpp	(revision 8127)
+++ trunk/BNC/qwt/qwt_plot_canvas.cpp	(revision 9383)
@@ -49,4 +49,10 @@
     }
 
+    virtual void drawRects(const QRect *rects, int count )
+    {
+        // to silence -Woverloaded-virtual
+        QwtNullPaintDevice::drawRects( rects, count );
+    }
+
     virtual void drawPath( const QPainterPath &path )
     {
@@ -73,5 +79,5 @@
         for ( int i = 0; i < path.elementCount(); i++ )
         {
-            QPainterPath::Element el = path.elementAt(i); 
+            QPainterPath::Element el = path.elementAt(i);
             switch( el.type )
             {
@@ -98,5 +104,5 @@
                     {
                         QRectF r = clipRects.last();
-                        r.setCoords( 
+                        r.setCoords(
                             qMin( r.left(), el.x ),
                             qMin( r.top(), el.y ),
@@ -170,5 +176,5 @@
         painter->setClipPath( borderClip, Qt::IntersectClip );
 
-    const QBrush &brush = 
+    const QBrush &brush =
         canvas->palette().brush( canvas->backgroundRole() );
 
@@ -186,6 +192,6 @@
         {
             rects += canvas->rect();
-        } 
-        else 
+        }
+        else
         {
             rects = painter->clipRegion().rects();
@@ -197,5 +203,5 @@
         if ( painter->paintEngine()->type() == QPaintEngine::X11 )
         {
-            // Qt 4.7.1: gradients on X11 are broken ( subrects + 
+            // Qt 4.7.1: gradients on X11 are broken ( subrects +
             // QGradient::StretchToDeviceMode ) and horrible slow.
             // As workaround we have to use the raster paintengine.
@@ -223,5 +229,5 @@
                 }
             }
-            
+
             QImage image( canvas->size(), format );
 
@@ -268,5 +274,5 @@
 }
 
-static QPainterPath qwtCombinePathList( const QRectF &rect, 
+static QPainterPath qwtCombinePathList( const QRectF &rect,
     const QList<QPainterPath> &pathList )
 {
@@ -286,5 +292,5 @@
             if ( br.center().y() < rect.center().y() )
             {
-                if ( qAbs( br.top() - rect.top() ) < 
+                if ( qAbs( br.top() - rect.top() ) <
                     qAbs( br.left() - rect.left() ) )
                 {
@@ -298,5 +304,5 @@
             else
             {
-                if ( qAbs( br.bottom() - rect.bottom() ) < 
+                if ( qAbs( br.bottom() - rect.bottom() ) <
                     qAbs( br.left() - rect.left() ) )
                 {
@@ -316,5 +322,5 @@
             if ( br.center().y() < rect.center().y() )
             {
-                if ( qAbs( br.top() - rect.top() ) < 
+                if ( qAbs( br.top() - rect.top() ) <
                     qAbs( br.right() - rect.right() ) )
                 {
@@ -328,5 +334,5 @@
             else
             {
-                if ( qAbs( br.bottom() - rect.bottom() ) < 
+                if ( qAbs( br.bottom() - rect.bottom() ) <
                     qAbs( br.right() - rect.right() ) )
                 {
@@ -340,5 +346,5 @@
             if ( subPath.currentPosition().y() < br.center().y() )
                 qwtRevertPath( subPath );
-        }   
+        }
         ordered[index] = subPath;
     }
@@ -381,5 +387,5 @@
 }
 
-static inline void qwtDrawStyledBackground( 
+static inline void qwtDrawStyledBackground(
     QWidget *w, QPainter *painter )
 {
@@ -418,5 +424,5 @@
 }
 
-static void qwtFillBackground( QPainter *painter, 
+static void qwtFillBackground( QPainter *painter,
     QWidget *widget, const QVector<QRectF> &fillRects )
 {
@@ -521,5 +527,5 @@
 };
 
-/*! 
+/*!
   \brief Constructor
 
@@ -595,5 +601,5 @@
                     *d_data->backingStore = grab( rect() );
 #else
-                    *d_data->backingStore = 
+                    *d_data->backingStore =
                         QPixmap::grabWidget( this, rect() );
 #endif
@@ -695,17 +701,17 @@
 bool QwtPlotCanvas::event( QEvent *event )
 {
-    if ( event->type() == QEvent::PolishRequest ) 
+    if ( event->type() == QEvent::PolishRequest )
     {
         if ( testPaintAttribute( QwtPlotCanvas::Opaque ) )
         {
-            // Setting a style sheet changes the 
+            // Setting a style sheet changes the
             // Qt::WA_OpaquePaintEvent attribute, but we insist
             // on painting the background.
-            
+
             setAttribute( Qt::WA_OpaquePaintEvent, true );
         }
     }
 
-    if ( event->type() == QEvent::PolishRequest || 
+    if ( event->type() == QEvent::PolishRequest ||
         event->type() == QEvent::StyleChange )
     {
@@ -729,5 +735,12 @@
     {
         QPixmap &bs = *d_data->backingStore;
-        if ( bs.size() != size() )
+
+        qreal pixelRatio = 1.0;
+
+#if QT_VERSION >= 0x050000
+        pixelRatio = bs.devicePixelRatio();
+#endif
+
+        if ( bs.size() != size() * pixelRatio )
         {
             bs = QwtPainter::backingStore( this, size() );
@@ -806,5 +819,5 @@
             drawCanvas( &painter, false );
 
-            if ( frameWidth() > 0 ) 
+            if ( frameWidth() > 0 )
                 drawBorder( &painter );
         }
@@ -815,13 +828,13 @@
 }
 
-void QwtPlotCanvas::drawCanvas( QPainter *painter, bool withBackground ) 
+void QwtPlotCanvas::drawCanvas( QPainter *painter, bool withBackground )
 {
     bool hackStyledBackground = false;
 
-    if ( withBackground && testAttribute( Qt::WA_StyledBackground ) 
+    if ( withBackground && testAttribute( Qt::WA_StyledBackground )
         && testPaintAttribute( HackStyledBackground ) )
     {
         // Antialiasing rounded borders is done by
-        // inserting pixels with colors between the 
+        // inserting pixels with colors between the
         // border color and the color on the canvas,
         // When the border is painted before the plot items
@@ -853,5 +866,5 @@
 
                 painter->setPen( Qt::NoPen );
-                painter->setBrush( d_data->styleSheet.background.brush ); 
+                painter->setBrush( d_data->styleSheet.background.brush );
                 painter->setBrushOrigin( d_data->styleSheet.background.origin );
                 painter->setClipPath( d_data->styleSheet.borderPath );
@@ -894,5 +907,5 @@
     if ( !d_data->styleSheet.borderPath.isEmpty() )
     {
-        painter->setClipPath( 
+        painter->setClipPath(
             d_data->styleSheet.borderPath, Qt::IntersectClip );
     }
@@ -930,5 +943,5 @@
         if ( frameWidth() > 0 )
         {
-            QwtPainter::drawRoundedFrame( painter, QRectF( frameRect() ), 
+            QwtPainter::drawRoundedFrame( painter, QRectF( frameRect() ),
                 d_data->borderRadius, d_data->borderRadius,
                 palette(), frameWidth(), frameStyle() );
@@ -953,5 +966,5 @@
 #endif
 
-        switch (frameShape) 
+        switch (frameShape)
         {
             case QFrame::Box:
@@ -963,7 +976,7 @@
                 opt.lineWidth = lineWidth();
                 opt.midLineWidth = midLineWidth();
-                break; 
-            }
-            default: 
+                break;
+            }
+            default:
             {
                 opt.lineWidth = frameWidth();
@@ -971,5 +984,5 @@
             }
         }
-    
+
         if ( frameShadow == Sunken )
             opt.state |= QStyle::State_Sunken;
@@ -1030,11 +1043,11 @@
 
     QwtStyleSheetRecorder recorder( size() );
-    
+
     QPainter painter( &recorder );
-    
+
     QStyleOption opt;
     opt.initFrom(this);
     style()->drawPrimitive( QStyle::PE_Widget, &opt, &painter, this);
-    
+
     painter.end();
 
@@ -1046,5 +1059,5 @@
         if ( !recorder.border.rectList.isEmpty() )
         {
-            d_data->styleSheet.borderPath = 
+            d_data->styleSheet.borderPath =
                 qwtCombinePathList( rect(), recorder.border.pathList );
         }
@@ -1097,5 +1110,5 @@
         return path;
     }
-    
+
     return QPainterPath();
 }
